<?php
/*
 * $Id: phpSmartIRCclass.inc.php,v 1.11 2002/11/04 23:43:30 meebey Exp $
 * $Revision: 1.11 $
 * $Author: meebey $
 * $Date: 2002/11/04 23:43:30 $
 */
/* phpSmartIRCclass
 * communication for PHP with IRC networks
 *
 * example of how you could use this class
 * <http://www.meebey.net/showcode.php?file=example>
 * here a service bot which I am also developing
 * <http://www.meebey.net/showcode.php?file=antitroll>
 * latest versions of phpSmartIRCclass you will find on my homepage
 *
 * phpSmartIRCclass conforms to RFC 2812 (Internet Relay Chat: Client Protocol)
 * 
 * Copyright (C) 2002 Mirco "MEEBEY" Bauer <mail@meebey.net> <http://www.meebey.net>
 * 
 * Full text of GPL License: <http://www.meebey.net/gpl.txt>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/ 
// ------- PHP code ----------

// dont change this! unless you know what you do
define( 'CRLF', "\r\n" );
define( 'STDOUT', 0 );
define( 'FILE', 1 );
define( 'SYSLOG', 2 );
define( 'PSIC_VERSION', '0.3.2' );
define( 'PSIC_VERSIONSTRING', 'phpSmartIRCclass '.PSIC_VERSION );
define( 'UNUSED', '*' );
define( 'STATE_DISCONNECTED', 0 );
define( 'STATE_CONNECTING',		1 );
define( 'STATE_CONNECTED',		2 );
define( 'DEBUG_NONE',					0);
define( 'DEBUG_NOTICE',				1 );
define( 'DEBUG_CONNECTION',			2 );
define( 'DEBUG_SOCKET',				4 );
define( 'DEBUG_IRCMESSAGES',			8 );
define( 'DEBUG_MESSAGETYPES',		16 );
define( 'DEBUG_ACTIONHANDLER',		32 );
define( 'DEBUG_ALL',					43 );
define( 'TYPE_UNKNOWN',				0 );
define( 'TYPE_CHANNEL',				1 );
define( 'TYPE_QUERY',					2 );
define( 'TYPE_CTCP',					3 );
define( 'TYPE_NOTICE',				4 );
define( 'TYPE_WHO',						5 );
define( 'TYPE_JOIN',					6 );
define( 'TYPE_INVITE',				7 );
define( 'TYPE_TOPICCHANGE',		8 );
define( 'TYPE_NICKCHANGE',		9 );
define( 'TYPE_KICK',					10 );
define( 'TYPE_QUIT',					11 );
define( 'TYPE_LOGIN',					12 );
define( 'TYPE_INFO',					13 );
define( 'TYPE_LIST',					14 );
define( 'TYPE_NAME',					15 );
define( 'TYPE_MOTD',					16 );
define( 'TYPE_MODECHANGE',			17 );
define( 'TYPE_PART',					18 );
define( 'TYPE_ERROR',					19 );
define( 'RPL_WELCOME',					'001' );
define( 'RPL_YOURHOST',					'002' );
define( 'RPL_CREATED',					'003' );
define( 'RPL_MYINFO',						'004' );
define( 'RPL_BOUNCE',						'005' );
define( 'RPL_TRACELINK',				'200' );
define( 'RPL_TRACECONNECTING',	'201' );
define( 'RPL_TRACEHANDSHAKE',		'202' );
define( 'RPL_TRACEUNKNOWN',			'203' );
define( 'RPL_TRACEOPERATOR',		'204' );
define( 'RPL_TRACEUSER',				'205' );
define( 'RPL_TRACESERVER',			'206' );
define( 'RPL_TRACESERVICE',			'207' );
define( 'RPL_TRACENEWTYPE',			'208' );
define( 'RPL_TRACECLASS',				'209' );
define( 'RPL_TRACERECONNECT',		'210' );
define( 'RPL_STATSLINKINFO',		'211' );
define( 'RPL_STATSCOMMANDS',		'212' );
define( 'RPL_ENDOFSTATS',				'219' );
define( 'RPL_UMODEIS',					'221' );
define( 'RPL_SERVLIST',					'234' );
define( 'RPL_SERVLISTEND',			'235' );
define( 'RPL_STATSUPTIME',			'242' );
define( 'RPL_STATSOLINE',				'243' );
define( 'RPL_LUSERCLIENT',			'251' );
define( 'RPL_LUSEROP',					'252' );
define( 'RPL_LUSERUNKNOWN',			'253' );
define( 'RPL_LUSERCHANNELS',		'254' );
define( 'RPL_LUSERME',					'255' );
define( 'RPL_ADMINME',					'256' );
define( 'RPL_ADMINLOC1',				'257' );
define( 'RPL_ADMINLOC2',				'258' );
define( 'RPL_ADMINEMAIL',				'259' );
define( 'RPL_TRACELOG',					'261' );
define( 'RPL_TRACEEND',					'262' );
define( 'RPL_TRYAGAIN',					'263' );
define( 'RPL_AWAY',							'301' );
define( 'RPL_USERHOST',					'302' );
define( 'RPL_ISON',							'303' );
define( 'RPL_UNAWAY',						'305' );
define( 'RPL_NOWAWAY',					'306' );
define( 'RPL_WHOISUSER',				'311' );
define( 'RPL_WHOISSERVER',			'312' );
define( 'RPL_WHOISOPERATOR',		'313' );
define( 'RPL_WHOWASUSER',				'314' );
define( 'RPL_ENDOFWHO',					'315' );
define( 'RPL_WHOISIDLE',				'317' );
define( 'RPL_ENDOFWHOIS',				'318' );
define( 'RPL_WHOISCHANNELS',		'319' );
define( 'RPL_LISTSTART',				'321' );
define( 'RPL_LIST',							'322' );
define( 'RPL_LISTEND',					'323' );
define( 'RPL_CHANNELMODEIS',		'324' );
define( 'RPL_UNIQOPIS',					'325' );
define( 'RPL_NOTOPIC',					'331' );
define( 'RPL_TOPIC',						'332' );
define( 'RPL_INVITING',					'341' );
define( 'RPL_SUMMONING',				'342' );
define( 'RPL_INVITELIST',				'346' );
define( 'RPL_ENDOFINVITELIST',	'347' );
define( 'RPL_EXCEPTLIST',				'348' );
define( 'RPL_ENDOFEXCEPTLIST',	'349' );
define( 'RPL_VERSION',					'351' );
define( 'RPL_WHOREPLY',					'352' );
define( 'RPL_NAMREPLY',					'353' );
define( 'RPL_LINKS',						'364' );
define( 'RPL_ENDOFLINKS',				'365' );
define( 'RPL_ENDOFNAMES',				'366' );
define( 'RPL_BANLIST',					'367' );
define( 'RPL_ENDOFBANLIST',			'368' );
define( 'RPL_ENDOFWHOWAS',			'369' );
define( 'RPL_INFO',							'371' );
define( 'RPL_MOTD',							'372' );
define( 'RPL_ENDOFINFO',				'374' );
define( 'RPL_MOTDSTART',				'375' );
define( 'RPL_ENDOFMOTD',				'376' );
define( 'RPL_YOUREOPER',				'381' );
define( 'RPL_REHASHING',				'382' );
define( 'RPL_YOURESERVICE',			'383' );
define( 'RPL_TIME',							'391' );
define( 'RPL_USERSSTART',				'392' );
define( 'RPL_USERS',						'393' );
define( 'RPL_ENDOFUSERS',				'394' );
define( 'RPL_NOUSERS',					'395' );
define( 'ERR_NOSUCHNICK',				'401' );
define( 'ERR_NOSUCHSERVER',			'402' );
define( 'ERR_NOSUCHCHANNEL',		'403' );
define( 'ERR_CANNOTSENDTOCHAN',	'404' );
define( 'ERR_TOOMANYCHANNELS',	'405' );
define( 'ERR_WASNOSUCHNICK',		'406' );
define( 'ERR_TOOMANYTARGETS',		'407' );
define( 'ERR_NOSUCHSERVICE',		'408' );
define( 'ERR_NOORIGIN',					'409' );
define( 'ERR_NORECIPIENT',			'411' );
define( 'ERR_NOTEXTTOSEND',			'412' );
define( 'ERR_NOTOPLEVEL',				'413' );
define( 'ERR_WILDTOPLEVEL',			'414' );
define( 'ERR_BADMASK',					'415' );
define( 'ERR_UNKNOWNCOMMAND',		'421' );
define( 'ERR_NOMOTD',						'422' );
define( 'ERR_NOADMININFO',			'423' );
define( 'ERR_FILEERROR',				'424' );
define( 'ERR_NONICKNAMEGIVEN',	'431' );
define( 'ERR_ERRONEUSNICKNAME',	'432' );
define( 'ERR_NICKNAMEINUSE',		'433' );
define( 'ERR_NICKCOLLISION',		'436' );
define( 'ERR_UNAVAILRESOURCE',	'437' );
define( 'ERR_USERNOTINCHANNEL',	'441' );
define( 'ERR_NOTONCHANNEL',			'442' );
define( 'ERR_USERONCHANNEL',		'443' );
define( 'ERR_NOLOGIN',					'444' );
define( 'ERR_SUMMONDISABLED',		'445' );
define( 'ERR_USERSDISABLED',		'446' );
define( 'ERR_NOTREGISTERED',		'451' );
define( 'ERR_NEEDMOREPARAMS',		'461' );
define( 'ERR_ALREADYREGISTRED',	'462' );
define( 'ERR_NOPERMFORHOST',		'463' );
define( 'ERR_PASSWDMISMATCH',		'464' );
define( 'ERR_YOUREBANNEDCREEP',	'465' );
define( 'ERR_YOUWILLBEBANNED',	'466' );
define( 'ERR_KEYSET',						'467' );
define( 'ERR_CHANNELISFULL',		'471' );
define( 'ERR_UNKNOWNMODE',			'472' );
define( 'ERR_INVITEONLYCHAN',		'473' );
define( 'ERR_BANNEDFROMCHAN',		'474' );
define( 'ERR_BADCHANNELKEY',		'475' );
define( 'ERR_BADCHANMASK',			'476' );
define( 'ERR_NOCHANMODES',			'477' );
define( 'ERR_BANLISTFULL',			'478' );
define( 'ERR_NOPRIVILEGES',			'481' );
define( 'ERR_CHANOPRIVSNEEDED',	'482' );
define( 'ERR_CANTKILLSERVER',		'483' );
define( 'ERR_RESTRICTED',				'484' );
define( 'ERR_UNIQOPPRIVSNEEDED','485' );
define( 'ERR_NOOPERHOST',				'491' );
define( 'ERR_UMODEUNKNOWNFLAG',	'501' );
define( 'ERR_USERSDONTMATCH',		'502' );

class CphpSmartIRCclass
{
	var $_socket;
	var $_address;
	var $_port;
	var $_nick;
	var $_username;
	var $_realname;
	var $_state = FALSE;
	var $_actionhandler = array();
	var $_debug = DEBUG_NOTICE;
	var $_messagebuffer = array();
	var $_lasttimestamp;
	var $_usesockets = FALSE;
	var $_receivedelay = 250;
	var $_senddelay = 250;
	var $_logdestination = STDOUT;
	var $_logfilefp;
	var $_logfile = 'phpSmartIRCclass.log';
	var $_disconnecttime = 1000;
	var $_benchmark = FALSE;
	var $_benchmark_starttime;
	var $_benchmark_endtime;

	function CphpSmartIRCclass()
	{
		ob_implicit_flush();
		set_time_limit(0);
		ignore_user_abort(TRUE);
		$this->_lasttimestamp = time();
	}
	
	/**
	 * @return void
	 * @param boolean bool
	 * @desc enables/disables the usage of real sockets
	 */
	function usesockets( $boolean )
	{
		if( $boolean == TRUE )
		{
			if(array_search('sockets',get_loaded_extensions()) !== FALSE)
			{
				$this->_usesockets = TRUE;
			}
			else
			{
				$this->log( DEBUG_NOTICE, 'WARNING: your PHP build doesn\'t support real sockets, will use fsocks' );
				$this->_usesockets = FALSE;
			}
		}
		else
		{
			$this->_usesockets = FALSE;
		}
	}

	/**
	 * @return void
	 * @param level int
	 * @desc sets the level of debug messages
	 */
	function debug( $level )
	{
		$this->_debug = $level;
	}

	/**
	 * @return void
	 * @param boolean bool
	 * @desc enables/disables benchmark test
	 */
	function benchmark( $boolean )
	{
		if(is_bool($boolean))
			$this->_benchmark = $boolean;
		else 
			$this->_benchmark = FALSE;
	}

	/**
	 * @return void
	 * @desc starts the benchmark
	 */
	function benchmarkstart()
	{
		$this->_benchmark_starttime = $this->microint();
	}

	/**
	 * @return void
	 * @desc ends the benchmark
	 */
	function benchmarkend()
	{
		$this->_benchmark_endtime = $this->microint();
		
		if($this->_benchmark)
			$this->show_benchmark();
	}

	/**
	 * @return void
	 * @param boolean bool
	 * @desc enables/disables benchmark test
	 */
	function show_benchmark()
	{
		$this->log( DEBUG_NOTICE, 'benchmark time: '.((float)$this->_benchmark_endtime-(float)$this->_benchmark_starttime).'</center>' );
	}

	/**
	 * @return void
	 * @param level int
	 * @param entry string
	 * @desc adds an entry to the log
	 */
	function log( $level, $entry )
	{
		if(!($level & $this->_debug))
			return;
		
		if(substr( $entry, -1 ) != "\n")
			$entry .= "\n";

		$formatedentry = date('M d H:i:s ').$entry;
			
		if($this->_logdestination == STDOUT)
		{
			echo($formatedentry);
		}
		elseif($this->_logdestination == FILE)
		{
			if(!is_resource($this->_logfilefp))
				$this->_logfilefp = @fopen($this->_logfile,'w+');

			@fwrite( $this->_logfilefp, $formatedentry );
			fflush($this->_logfilefp);
		}
		elseif($this->_logdestination == SYSLOG)
		{
			define_syslog_variables();
			
			if(!is_int($this->_logfilefp))
				$this->_logfilefp = openlog('phpSmartIRCclass', LOG_NDELAY, LOG_DAEMON );
				
			syslog( LOG_INFO, $entry );
		}
	}
	
	/**
	 * @return void
	 * @param type constant
	 * @desc sets the destination of all log messages
	 */
	function setlogdestination( $type )
	{
		if( $type == FILE )
			$this->_logdestination = FILE;
		elseif( $type == STDOUT )
			$this->_logdestination = STDOUT;
		elseif( $type == SYSLOG )
			$this->_logdestination = SYSLOG;
		else
		{
			$this->log( DEBUG_NOTICE, 'WARNING: unknown logdestination type ('.$type.'), will use STDOUT instead' );
			$this->_logdestination = STDOUT;
		}
	}
	
	/**
	 * @return void
	 * @param file string
	 * @desc sets the file for the log if the destination is set to file
	 */
	function setlogfile( $file )
	{
		$this->_logfile = $file;
	}

	/**
	 * @return void
	 * @param milliseconds int
	 * @desc sets the delaytime before closing the socket when disconnect
	 */
	function disconnecttime( $milliseconds )
	{
		if(is_integer($milliseconds) && $milliseconds >= 100)
			$this->_disconnecttime = $milliseconds;
		else
			$this->_disconnecttime = 100;
	}

	/**
	 * @return void
	 * @param milliseconds int
	 * @desc sets the delay for receiving data from the IRC server
	 */
	function receivedelay( $milliseconds )
	{
		if(is_integer($milliseconds) && $milliseconds >= 100)
			$this->_receivedelay = $milliseconds;
		else
			$this->_receivedelay = 100;
	}

	/**
	 * @return void
	 * @param milliseconds int
	 * @desc sets the delay for sending data to the IRC server
	 */
	function senddelay( $milliseconds )
	{
		if(is_integer($milliseconds))
			$this->_senddelay = $milliseconds;
		else
			$this->_senddelay = 250;
	}
	
	/**
	 * @return void
	 * @param address string
	 * @param port int
	 * @desc creates the sockets and connects to the IRC server
	 */
	function connect( $address, $port )
	{
		$this->log( DEBUG_CONNECTION, 'DEBUG_CONNECTION: connecting' );
		$this->_address = $address;
		$this->_port = $port;
		
		if($this->_usesockets == TRUE)
		{
			$this->log( DEBUG_SOCKET, 'DEBUG_SOCKET: using real sockets' );
			$this->_socket = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
			$result = @socket_connect( $this->_socket, $this->_address, $this->_port );
		}
		else
		{
			$this->log( DEBUG_SOCKET, 'DEBUG_SOCKET: using fsockets' );
			$this->_socket = @fsockopen( $this->_address, $this->_port );
			$this->log( DEBUG_SOCKET, 'DEBUG_SOCKET: nonblocking socket mode' );
			socket_set_blocking( $this->_socket, FALSE );
		}

		$this->updatestate();
	}
	
	/**
	 * @return void
	 * @param nick string
	 * @param realname string
	 * @param username string
	 * @param password string
	 * @param realname string
	 * @desc creates the sockets and connects to the IRC server
	 */
	function login( $nick, $realname, $username = NULL, $password = NULL )
	{
		$this->log( DEBUG_CONNECTION, 'DEBUG_CONNECTION: logging in' );

		$this->_nick = str_replace( ' ', '', $nick );
		$this->_realname = $realname;
		
		if($username != NULL)
			$this->_username = str_replace( ' ', '', $username );
		else
			$this->_username = exec('whoami');

		if($password != NULL)
			$this->rawsend( 'PASS '.$password );

		$mode = '0';
		$this->rawsend( 'NICK '.$this->_nick );
		$this->rawsend( 'USER '.$this->_username.' '.$mode.' '.UNUSED.' :'.$this->_realname );
	}
	
	/**
	 * @return void
	 * @desc changes a already used nickname to a new nickname plus 3 random digits
	 */
	function nicknameinuse()
	{
		$this->rawsend( 'NICK '.substr( $this->_nick, 0, 5 ).rand( 0, 999 ) );
	}

	/**
	 * @return bool
	 * @param rawsend string
	 * @desc sends a raw message to the IRC server
	 */
	function rawsend($data)
	{
		if($this->state() == STATE_CONNECTED)
		{
			$this->log( DEBUG_IRCMESSAGES, 'DEBUG_IRCMESSAGES: sent: "'.$data.'"' );
				
			if($this->_usesockets == TRUE)
				$result = @socket_write( $this->_socket, $data.CRLF );
			else
				$result = @fwrite( $this->_socket, $data.CRLF );
			
			
			if($result == FALSE)
				return FALSE;
			else
				return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	/**
	 * @return void
	 * @param data string
	 * @desc adds a message to the messagebuffer
	 */
	function bufferedsend($data)
	{
		array_push( $this->_messagebuffer, $data );
	}
	
	/**
	 * @return void
	 * @desc checks the buffer if there are messages to send
	 */
	function checkbuffer()
	{
		$messagecount = count($this->_messagebuffer);
		
		if( time() >= $this->_lasttimestamp+1 && $messagecount > 0 )
		{
			$this->rawsend( array_shift( $this->_messagebuffer ) );
		
			if( $messagecount > 1 )
			{
				$this->rawsend( array_shift( $this->_messagebuffer ) );
			}
				
			$this->_lasttimestamp = time();
		}
	}	

	/**
	 * @return void
	 * @desc goes into main idle loop for waiting messages from the IRC server
	 */
	function rawreceive()
	{
		$lastpart = '';
		$rawdataar = array();
		
		while($this->state() == STATE_CONNECTED)
		{
			if($this->_usesockets == TRUE)
			{
				$sread = array($this->_socket);
				$result = @socket_select( $sread, $w = NULL, $e = NULL,  0, $this->_receivedelay*1000 );
				
				if( $result == 1)
					// the socket got data to read
					$rawdata = @socket_read( $this->_socket, 512 );
				else
					// no data
					$rawdata = NULL;
			}
			else
			{
				usleep($this->_receivedelay*1000);
/*
				doesn't work somehow, something broken in PHP?
				using nonblocking sockets right now as workaround
				
				$status = socket_get_status ($this->_socket);
				$bytes = $status['unread_bytes'];
				
				if($bytes > 0)
*/
					$rawdata = @fread( $this->_socket, 512 );
/*
				else
					$rawdata = NULL;
*/
			}
			
			$this->checkbuffer();
			
			if($rawdata != NULL)
			{
				$rawdata = str_replace( "\r", '', $rawdata );
				$rawdata = $lastpart.$rawdata;
				
				$lastpart = substr( $rawdata, strrpos($rawdata ,"\n")+1 );
				$rawdata = substr( $rawdata, 0, strrpos($rawdata ,"\n") );
				$rawdataar = explode( "\n", $rawdata );   
			}
			
			for( $i= 0; $i < sizeof($rawdataar); $i++ )
			{
        			$rawline = array_shift($rawdataar);
        			
				$this->log( DEBUG_IRCMESSAGES, 'DEBUG_IRCMESSAGES: received: "'.$rawline.'"' );
					
				if(substr( $rawline, 0, 4 ) == 'PING')
				{
					$this->pong(substr( $rawline, 5 ));
				}
				elseif(substr( $rawline, 0, 5 ) == 'ERROR')
				{
					$this->disconnect( TRUE );
				}

				if(substr( $rawline, 0, 1 ) == ':')
				{
					$line = substr( $rawline, 1 );
					$lineex = explode( ' ', $line );
					$from = $lineex[0];
					$nick = substr( $lineex[0], 0, strpos( $lineex[0], '!' ) );
					$message = substr( implode( array_slice( $lineex, 3 ), ' ' ), 1 );
					$type = $this->gettype( $rawline );
					
					if($type == TYPE_CTCP)
					{
						if(substr( $message, 1, 4 ) == 'PING')
							$this->message( TYPE_CTCP, $nick, 'PING '.substr( $message, 5, -1 ) );
						elseif(substr( $message, 1, 7 ) == 'VERSION')
							$this->message( TYPE_CTCP, $nick, 'VERSION '.PSIC_VERSIONSTRING.' by Mirco "MEEBEY" Bauer <http://www.meebey.net> | PHP version: '.phpversion() );
					}
					elseif($type == TYPE_ERROR)
					{
						$code = $lineex[1];
						
						if($code == ERR_NICKNAMEINUSE)
							$this->nicknameinuse();
					}
       		
					$handler = &$this->_actionhandler;
					for( $j=0; $j<count($handler); $j++)
					{
						$handlerobject = &$handler[$j];
						
						if($handlerobject->type == $type)
						{
							if(ereg($handlerobject->message,$message) == 1)
							{
								$ircdata = &new CphpSmartIRCclass_data();
								$ircdata->nick = $nick;
								$ircdata->from = $from;
								$ircdata->message = $message;
								$ircdata->rawmessage = $rawline;
					
								$methodobject = &$handlerobject->object;
								$method = $handlerobject->method;
					
								if(method_exists( $methodobject, $method ))
									$methodobject->$method( $ircdata );
									
								unset($ircdata);
								break;
							}
						}
					}
				}	
			}
		}
	}
	
	/**
	 * @return void
	 * @param data string
	 * @desc sends the pong for keeping alive
	 */
	function pong($data)
	{
		$this->log( DEBUG_CONNECTION, 'DEBUG_CONNECTION: Ping? Pong!' );
			
		$this->rawsend('PONG '.$data);
	}

	/**
	 * @return void
	 * @param channel string
	 * @param key string
	 * @desc joins an IRC channel
	 */
	function join( $channel, $key = NULL )
	{
		if($key != NULL)
			$this->bufferedsend('JOIN '.$channel.' '.$key);
		else
			$this->bufferedsend('JOIN '.$channel);
	}

	/**
	 * @return void
	 * @param channelarray mixed
	 * @param reason string
	 * @desc parts one or more IRC channels
	 */
	function part( $channelarray, $reason = NULL)
	{
		if(!is_array($channelarray))
			$channelarray = array($channelarray);

		$channellist = implode( $channelarray, ',' );
		
		if($reason != NULL)
			$this->bufferedsend('PART '.$channellist.' :'.$reason);
		else
			$this->bufferedsend('PART '.$channellist);
	}

	/**
	 * @return void
	 * @param channel string
	 * @param nickname string
	 * @param reason string
	 * @desc kicks a user from a IRC channel
	 */
	function kick( $channel, $nickname, $reason = NULL )
	{
		if($reason != NULL)
			$this->rawsend('KICK '.$channel.' '.$nickname.' :'.$reason);
		else
			$this->rawsend('KICK '.$channel.' '.$nickname);
	}

	/**
	 * @return void
	 * @param channelarray mixed
	 * @desc gets a list of one ore more channels
	 */
	function getlist($channelarray = NULL)
	{
		if($channelarray != NULL)
		{
			if(!is_array($channelarray))
				$channelarray = array($channelarray);
			
			$channellist = implode( $channelarray, ',' );
			$this->bufferedsend('LIST '.$channellist);
		}
		else
			$this->bufferedsend('LIST');
	}

	/**
	 * @return void
	 * @param channelarray mixed
	 * @desc gets all nicknames of one or more channels
	 */
	function names($channelarray = NULL)
	{
		if($channelarray != NULL)
		{
			if(!is_array($channelarray))
				$channelarray = array($channelarray);

			$channellist = implode( $channelarray, ',' );
			$this->bufferedsend('NAMES '.$channellist);
		}
		else
			$this->bufferedsend('NAMES');
	}

	/**
	 * @return void
	 * @param channel string
	 * @param newtopic string
	 * @desc sets a new topic of a channel
	 */
	function settopic( $channel, $newtopic )
	{
		$this->bufferedsend('TOPIC '.$channel.' :'.$newtopic);
	}

	/**
	 * @return void
	 * @param channel string
	 * @desc gets the topic of a channel
	 */
	function gettopic($channel)
	{
		$this->bufferedsend('TOPIC '.$channel);
	}

	/**
	 * @return void
	 * @param target string
	 * @param newmode string
	 * @desc sets or gets the mode of an user or channel
	 */
	function mode( $target, $newmode = NULL )
	{
		if($newmode != NULL)
			$this->bufferedsend('MODE '.$target.' '.$newmode);
		else 
			$this->bufferedsend('MODE '.$target);
	}

	/**
	 * @return void
	 * @param channel string
	 * @param nickname string
	 * @desc ops an user in the given channel
	 */
	function op( $channel, $nickname )
	{
		$this->mode( $channel, '+o '.$nickname );
	}

	/**
	 * @return void
	 * @param channel string
	 * @param nickname string
	 * @desc deops an user in the given channel
	 */
	function deop( $channel, $nickname )
	{
		$this->mode( $channel, '-o '.$nickname );
	}

	/**
	 * @return void
	 * @param channel string
	 * @param nickname string
	 * @desc bans a hostmask for the given channel
	 */
	function ban( $channel, $hostmask )
	{
		$this->mode( $channel, '+b '.$hostmask );
	}

	/**
	 * @return void
	 * @param channel string
	 * @param nickname string
	 * @desc unbans a hostmask for the given channel
	 */
	function unban( $channel, $hostmask )
	{
		$this->mode( $channel, '-b '.$hostmask );
	}

	/**
	 * @return void
	 * @param nickname string
	 * @param channel string
	 * @desc invites a user to a channel
	 */
	function invite( $nickname, $channel )
	{
		$this->bufferedsend('INVITE '.$nickname.' '.$channel);
	}

	/**
	 * @return void
	 * @param newnick string
	 * @desc changes the own nickname
	 */
	function changenick($newnick)
	{
		$this->bufferedsend('NICK '.$newnick);
	}
	
	/**
	 * @return void
	 * @desc goes into receive mode
	 */
	function listen()
	{
		if($this->state() == STATE_CONNECTED)
		{
			$this->rawreceive();
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	/**
	 * @return void
	 * @param messagetype constant
	 * @param result array
	 * @desc waits for a special message type and puts the answer it in $result
	 */
	function listen_for( $messagetype, &$result )
	{
		$listenfor = &new CphpSmartIRCclass_listenfor( $this );
		$this->register_actionhandler( $messagetype, '.*', $listenfor, 'handler' );
		$this->listen();
		$result = $listenfor->result;
		unset($listenfor);
	}
	
	/**
	 * @return bool
	 * @param type constant
	 * @param destination string
	 * @param message string
	 * @desc sends a new message
	 */
	function message( $type, $destination, $message )
	{
		if($type == TYPE_CHANNEL || $type == TYPE_QUERY)
			$this->bufferedsend('PRIVMSG '.$destination.' :'.$message);
		elseif($type == TYPE_NOTICE)
			$this->bufferedsend('NOTICE '.$destination.' :'.$message);
		elseif($type == TYPE_CTCP)
			$this->bufferedsend('NOTICE '.$destination.' :'.chr(1).$message.chr(1));
		else
			return FALSE;
			
		return TRUE;
	}

	/**
	 * @return void
	 * @param handlertype constant
	 * @param regexhandler string
	 * @param object object
	 * @param methodname string
	 * @desc registers a new actionhandler
	 */
	function register_actionhandler( $handlertype, $regexhandler, &$object, $methodname )
	{
		$newactionhandler = &new CphpSmartIRCclass_actionhandler();
		$newactionhandler->type = $handlertype;
		$newactionhandler->message = $regexhandler;
		$newactionhandler->object = &$object;
		$newactionhandler->method = $methodname;
		
		array_push( $this->_actionhandler, $newactionhandler );
	}
	
	/**
	 * @return constant
	 * @param line string
	 * @desc determines the messagetype of $line
	 */
	function gettype($line)
	{
		if(ereg( '^:.* [0-9]{3} .*$', $line ) == 1)
		{
			$lineex = explode( ' ', $line );
			$code = $lineex[1];
				
			if($code == RPL_WELCOME)
				return TYPE_LOGIN;
			elseif($code == RPL_YOURHOST)
				return TYPE_LOGIN;
			elseif($code == RPL_CREATED)
				return TYPE_LOGIN;
			elseif($code == RPL_MYINFO)
				return TYPE_LOGIN;
			elseif($code == RPL_BOUNCE)
				return TYPE_LOGIN;
			elseif($code == RPL_LUSERCLIENT)
				return TYPE_INFO;
			elseif($code == RPL_LUSEROP)
				return TYPE_INFO;
			elseif($code == RPL_LUSERUNKNOWN)
				return TYPE_INFO;
			elseif($code == RPL_LUSERME)
				return TYPE_INFO;
			elseif($code == RPL_LUSERCHANNELS)
				return TYPE_INFO;
			elseif($code == RPL_MOTDSTART)
				return TYPE_MOTD;
			elseif($code == RPL_MOTD)
				return TYPE_MOTD;
			elseif($code == RPL_ENDOFMOTD)
				return TYPE_MOTD;
			elseif($code == RPL_NAMREPLY)
				return TYPE_NAME;
			elseif($code == RPL_ENDOFNAMES)
				return TYPE_NAME;
			elseif($code == RPL_WHOREPLY)
				return TYPE_WHO;
			elseif($code == RPL_ENDOFWHO)
				return TYPE_WHO;
			elseif($code == RPL_LISTSTART)
				return TYPE_LIST;
			elseif($code == RPL_LIST)
				return TYPE_LIST;
			elseif($code == RPL_LISTEND)
				return TYPE_LIST;
			elseif($code == ERR_NICKNAMEINUSE)
				return TYPE_ERROR;
			else
				$this->log( DEBUG_IRCMESSAGES, 'DEBUG_IRCMESSAGES: replycode UNKNOWN ('.$code.'): "'.$line.'"' );
		}

		if(ereg( '^:.* PRIVMSG #.* :.*$', $line ) == 1)
			return TYPE_CHANNEL;
		elseif(ereg( '^:.* PRIVMSG .* :'.chr(1).'.*'.chr(1).'$', $line ) == 1)
			return TYPE_CTCP;
		elseif(ereg( '^:.* PRIVMSG .*:.*$', $line ) == 1)
			return TYPE_QUERY;
		elseif(ereg( '^:.* NOTICE .* :.*$', $line ) == 1)
			return TYPE_NOTICE;
		elseif(ereg( '^:.* INVITE .* .*$', $line ) == 1)
			return TYPE_INVITE;
		elseif(ereg( '^:.* JOIN .*$', $line ) == 1)
			return TYPE_JOIN;
		elseif(ereg( '^:.* TOPIC .* :.*$', $line ) == 1)
			return TYPE_TOPICCHANGE;
		elseif(ereg( '^:.* NICK .*$', $line ) == 1)
			return TYPE_NICKCHANGE;
		elseif(ereg( '^:.* KICK .* .*$', $line ) == 1)
			return TYPE_KICK;
		elseif(ereg( '^:.* PART .* :.*$', $line ) == 1)
			return TYPE_PART;
		elseif(ereg( '^:.* MODE .* .*$', $line ) == 1)
			return TYPE_MODECHANGE;
		elseif(ereg( '^:.* QUIT :.*$', $line ) == 1)
			return TYPE_QUIT;
		else 
		{
			$this->log( DEBUG_MESSAGETYPES, 'DEBUG_MESSAGETYPES: TYPE_UNKNOWN!: "'.$line.'"' );
				
 			return TYPE_UNKNOWN;
		}
	}
	
	/**
	 * @return void
	 * @param target string
	 * @desc requests a WHO from the specified target
	 */
	function who( $target )
	{
		$this->bufferedsend('WHO '.$target);
	}

	/**
	 * @return void
	 * @param target string
	 * @desc requests a WHOIS from the specified target
	 */
	function whois( $target )
	{
		$this->bufferedsend('WHOIS '.$target);
	}

	/**
	 * @return void
	 * @param target string
	 * @desc requests a WHOWAS from the specified target
	 */
	function whowas( $target )
	{
		$this->bufferedsend('WHOWAS '.$target);
	}
	
	/**
	 * @return void
	 * @param quitmessage string
	 * @desc sends QUIT to IRC server and disconnects
	 */
	function quit($quitmessage = NULL)
	{
		if($quitmessage != NULL)
			$this->bufferedsend('QUIT :'.$quitmessage);
		else
			$this->bufferedsend('QUIT');
			
		$this->disconnect( TRUE );
	}
	
	/**
	 * @return bool
	 * @desc updates the current connection state
	 */
	function updatestate()
	{
		$rtype = get_resource_type($this->_socket);
		if( is_resource($this->_socket) && $this->_socket !== FALSE && ( $rtype == 'socket' || $rtype == 'Socket' ) )
		{
			$this->_state = TRUE;
			return TRUE;
		}
		else
		{
			$this->_state = FALSE;
			return FALSE;
		}
	}
	
	/**
	 * @return constant
	 * @desc returns the current connection state
	 */
	function state()
	{
		$result = $this->updatestate();
		
		if($result == TRUE)
			return STATE_CONNECTED;
		else
			return STATE_DISCONNECTED;
	}
	
	/**
	 * @return bool
	 * @param quickdisconnect bool
	 * @desc disconnects from the IRC server nicely with a QUIT or just destroys the socket
	 */
	function disconnect($quickdisconnect = FALSE)
	{
		if($this->state() == STATE_CONNECTED)
		{
			if($quickdisconnect == FALSE)
			{
				$this->rawsend('QUIT');
				usleep($this->_disconnecttime*1000);
			}
			
			if($this->_usesockets == TRUE)	
			{
				@socket_shutdown( $this->_socket );
				socket_close( $this->_socket );
			}
			else
			{
				fclose( $this->_socket );
			}

			$this->updatestate();
			
			$this->log( DEBUG_CONNECTION, 'DEBUG_CONNECTION: disconnected' );
				
			return TRUE;
		}
		else
		{
			return FALSE;
		}

		if($this->_logdestination == FILE)
			fclose($this->_logfilefp);
		elseif($this->_logdestination == SYSLOG)
			closelog();
	}
	
	/**
	 * @return float
	 * @desc getting current microtime, needed for benchmarks
	 */
	function microint()
	{
		$tmp = microtime();
		$parts = explode(" ", $tmp);
		$floattime = (float)$parts[0] + (float)$parts[1];
		return $floattime;
	}
}

class CphpSmartIRCclass_data
{
	var $nick;
	var $from;	
	var $message;
	var $rawmessage;
}

class CphpSmartIRCclass_actionhandler
{
	var $type;
	var $message;	
	var $object;
	var $method;
}

class CphpSmartIRCclass_listenfor
{
	var $irc;
	var $result = array();
			
	function CphpSmartIRCclass_listenfor( &$ircobject )
	{
		$this->irc = &$ircobject;
	}
	
	/**
	 * @return void
	 * @param ircdata object
	 * @desc stores the received answer into the result array
	 */
	function handler(&$ircdata)
	{
		$this->irc->log( DEBUG_ACTIONHANDLER, 'DEBUG_ACTIONHANDLER: listen_for handler called' );
		array_push( $this->result, $ircdata->message );
		$this->irc->disconnect(TRUE);
	}
}
?>